package wda;					// wda.Utils.version    002.1
/*

002.1	12/012	Int-> floor instead rint (-> RInt)






*/

/////   grep //--end Utils.j     -> (external) functions

import java.awt.*;	// -> AWTEvent, Color, Image, Graphics, Graphics2D
// import javax.swing.*;

import java.applet.*;	// -> Applet
import java.net.*;		// -> URL
import java.io.*;		// -> File
import javax.imageio.*; // -> ImageIO

import java.awt.image.BufferedImage;
import java.awt.MediaTracker;


/*****

import static wda.Utils;	// -> prt(), sleep(), Int(), readBImg(), resizeImg(), ...

===> BEFORE copying any function from one file to another, (try) put(ting) it into Utils !  <===

// NON-STATIC JAVASHIT CANNOT BE REFERENCED FROM A STATIC CONTEXT: loadImg(),  getBI(),  getImg(),

002	07/012
002.1	Math.rint() = Rounded ?????

*****/



public class Utils extends Applet		// -> MediaTracker
{
	final static String NL = new String( "\n" );
	final static String BL = new String( " " );

	final static boolean VB = true;
	final static boolean TEST = true;






// IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIImagestuff:


	static BufferedImage resizeImg(Image i, float f  )	{
		return resizeImg( i, Int(i.getWidth(null)*f), Int(i.getHeight(null)*f) );
	}//--end resizeImg( Image, float )

	static void drawImg( Graphics g, Image i, int x0, int y0, int w, int h) {
		g.drawImage( i, x0,y0, w,h, null );
	}//--end drawImg( Graphics, Image, int, int, int, int)

	static void drawImg( Graphics g, BufferedImage b, int x, int y ) {
		g.drawImage( b, x, y, null);	/// this ->cannotstatic
	}

	static BufferedImage resizeImg(Image i, int w2, int h2)
	{
		BufferedImage bI = new BufferedImage( w2, h2, BufferedImage.TYPE_INT_RGB );
		Graphics2D gr = bI.createGraphics();
//		gr.drawImage( i, 0,0, w2,h2, null);
		drawImg( gr, i, 0,0, w2,h2 );
		gr.dispose();	// ??
		return bI;

/*****
		if( false )
		{
			gr.setComposite(AlphaComposite.Src);
			gr.setRenderingHint(RenderingHints.KEY_INTERPOLATION,RenderingHints.VALUE_INTERPOLATION_BILINEAR);
			gr.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_QUALITY);
			gr.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
		}	//*****/

	}//-- end resizeImg( Image, int, int )




//================  wda's BITMAP-handling  ==================

	//    ===== SCALE BITMAP =====

	static int[][] tbmp;			// temp. BMP[h][ww*3], global for use in rgbval()
	static int[][] bmp1;
	static int h, w;

	static int[][] scaleBmp( int[][] bmp, int ww, int hh )		// scale (entire) BitMaP to ww*hh
	{
		// [h][w*3]
//		return scaleBmp( bmp, 0, 0, bmp[0].length/3, bmp.length, ww, hh );
		return scaleBmp( bmp, 0, 0, bmp[0].length/3*0.99, bmp.length*0.99, ww, hh );

	}//--end scaleBmp( int[][], int, int )

	static int[][] scaleBmp( int[][] bmp, double fact )		// scale (entire) BitMaP by ~fact
	{
		// [h][w*3]
		return scaleBmp( bmp, Int( bmp[0].length/3*fact), Int( bmp.length*fact )  );
	}//--end scaleBmp( int[][], double )

    static int[][] scaleBmp( int[][] bmp, double xm, double ym, double xx, double yx, int ww, int hh )
    // scale area xm/ym--xx/yx of BitMaP to wwh*hh
	{
		bmp1 = bmp;
		w = bmp[0].length/3;
		h = bmp.length;		// source dimensions

		int[][] b2;		// (don't like long names. like unique names.)
		b2 = new int[hh][ww*3];		// target

        double dx = (xx-xm)/ww;		// "Spaltenbreite"
        double dy = (yx-ym)/hh;		// "Zeilenhoehe"
        double f1, f2;

		// trying to KISS...  2-steps: ==1) scale x== saving temp. tbmp
		tbmp = new int[h][ww*3];		// height of source, width of target
		prt( "scaleBmp: " + xm + "..." + xx + "   " + ym + "..." + yx );
		prt( "scaleBmp: ww=" + ww + " hh=" + hh + "   w=" + w + " h=" + h );
		for(int ih=0; ih<h; ih++)		// Zeilen src==temp.target
		{
			for(int iw=0; iw<ww; iw++)	// target Spalte=pixel
			{
				int jw;
				double x1 = xm + iw*dx, x2 = x1 + dx;	// x-range to average over
				int ix1 = Int( x1 ); double rx1 = x1 - ix1;	// ix .. 'angeschnittene' Rand-pixel
				int ix2 = Int( x2 ); double rx2 = x2 - ix2;
				if(rx2==0) { ix2-=1; rx2 =1; }
//				if(ih==0) prt( "ix1=" + ix1 + "  ix2=" + ix2 );

				if( ix1==ix2 )		// copy values
				{
					for(int kk=0; kk<3; kk++) {
//						tbmp[ih][iw*3+kk] = bmp[ih][ix1*3+kk];
						tbmp[ih][iw*3+kk] = bmpval( ih, ix1*3+kk );
					}
				}
				else				// average values
				{
					f1 = 1.0 - rx1; f2 = rx2;		//  f...weights;  f*  0..1
					double rgb, sumf;
					for(int kk=0; kk<3; kk++)
					{
//						rgb = bmp[ih][ix1*3+kk]*f1 + bmp[ih][ix2*3+kk]*f2;
						rgb = bmpval( ih, ix1*3+kk )*f1 + bmpval( ih, ix2*3+kk )*f2;
						sumf = f1 + f2;		// sum of factors=weights
						for(int ii=ix1+1; ii<ix2; ii++)	// dazwischenliegende (ganze) pixel (bzw. spalten)
						{
//							rgb += bmp[ih][ii*3+kk];
							rgb += bmpval( ih, ii*3+kk );
							sumf += 1;
						}
						tbmp[ih][iw*3+kk] = Int( rgb/sumf );		// step1=transform_x done
					}

				}//--fi
			}//-- end for iw
		}//-- end for ih

		//  ==2) scale y== writing to outfile
		for(int ih=0; ih<hh; ih++)		// Zeilen target
		{
			double y1 = ym + ih*dy, y2 = y1 + dy;	// y-range to average over, real
			int iy1 = Int( y1 ); double ry1 = y1 - iy1;		// split Integer/Rest
			int iy2 = Int( y2 ); double ry2 = y2 - iy2;		//  0 <= r* < 1
			if(ry2==0) {  iy2-=1; ry2=1; }

			for(int iw=0; iw<ww; iw++)
			{
				for( int kk=0; kk<3; kk++ )
				{
					int jw = iw*3+kk;
					if( iy1==iy2 ){	// copy values
						b2[ih][jw] = rgbval( iy1, jw );
					}
					else			// average over lines
					{
						f1 = 1.0 - ry1; f2 = ry2;		//  f...weights
						double sumf = f1 + f2;		// sum of factors=weights
						double rgb = rgbval( iy1, jw )*f1 + rgbval( iy2, jw )*f2;	// rgbval(..) = tbmp(..) | 0 if out of bounds
						for(int ii=iy1+1; ii<iy2; ii++)
						{
							rgb += rgbval( ii, jw );
							sumf += 1;
						}
						b2[ih][jw] = (int)(rgb/sumf);
					}
				}//-- end for kk
			}//-- end for iw
		}//-- end for ih

		/// transform_x|y  SIND ja hoffentlich kommutativ?

		return b2;

	}//--end scaleBmp( int[][], double, double, double, double, int, int ) // bmp,xm,ym,xx,yx,w,h

	static int bmpval( int ih, int iw )		// allow for black margin when accessing source bmp
	{
		if( ih<0 || ih>=h || iw<0 || iw>=w*3 )	return 0;
		else                         return bmp1[ih][iw];
	}

	static int rgbval( int ih, int iw )		// allow for black margin when accessing temp bmp
	{
		if( ih<0 || ih>=h ) return 0;
//		if( iw<0 || iw>=w ) return 0;		// not used currently
//++		prt( "ih=" + ih + " iw=" + iw + "   bmp.length=" + bmp.length ); // + " bmp.length=" + bmp.length );
		return tbmp[ih][iw];
	}


	//   ===  "Multiply" BMP  ===
	static int[][] tileBmp( int[][] bmp, int nw, int nh)		// nw*w x nh*h
	{
		int w = bmp[0].length/3;
		h = bmp.length;				// source dimensions

		int ww = w*nw, hh = h*nh;		// dimensions of
		int[][] b3 = new int[hh][ww*3];	// target			hh*ww pixel, hh*3*ww bytes

		for( int ih=0; ih<h; ih++ )
			for( int i=0; i<nh; i++ )
				for( int jw=0; jw<w*3; jw++ )
					for( int j=0; j<nw; j++ ) {
						b3[i*h+ih][j*3*w+jw] = bmp[ih][jw];
					}
		return b3;

	}//--end tileBmp( int[][], int, int )



	//   ===  Write BMP to file:  ===

	static FileInputStream bmpin = null;
	static FileOutputStream bmpout = null;

	static int[][] readBmp( String fn, int w, int h) throws IOException	// read BMP and check image-size
	{
		int[][] bmp = readBmp( fn );
		int ww=bmp[0].length/3, hh=bmp.length;
		if( hh==h && ww==w )	return bmp;

		prt( "FATAL: " + fn + "-size=" + hh + " * " + ww + "; must be " + h + " * " + w + "." );
		System.exit(335);
		return null;	// FUKKKKJAVA
	}



	static int[][] readBmp( String fn ) throws IOException
	{
		int[][] bmp;
		bmpin  = new FileInputStream(fn);

		// -- read/parse header: --
        skipb( bmpin, 2 ); 		//skip "BM"
        long s = read4( bmpin );	// filesize NOT IN BYTES BUT IN WORDS - for chomini1.bmp at least
        skipb( bmpin, 4 );
		long  o = read4( bmpin );	// offset bmp-data
		long hs = read4( bmpin );	// headersize=40
		long  w = read4( bmpin );
		long  h = read4( bmpin );
		if( w%4 != 0) {
			prt("XXXXXXreadBmp.FATAL: NOT-supported width "+w+" (not-divisible by 4) in " + fn);
			System.exit(337);
		}
		skipb( bmpin, 2 );
		int bpp = read2( bmpin );
		long cm = read4( bmpin );	// Compression Method
		long is = read4( bmpin );	// image(bitmap)size
		skipb( bmpin, 16 );			// skip to start of bitmap

		if( bpp!=24 ) prt( "WWWWWWWWWWWWWWARNING! bpp=" + bpp );
		prt( "READING " +fn + ":  w=" + w + " h=" + h + "  s=" + s
			+ " offs=" + o + "  bpp=" + bpp + " cm=" + cm
			+ " isize=" + is);

		// -- read&save bitmap data: --
		bmp = new int[(int)h][(int)w*3];
		for(int ih=0; ih<h; ih++)			// die UNTERSTE Zeile kommt ZUERST !!
			for(int iw=0; iw<3*w; iw++) {
				bmp[ih][iw] = bmpin.read();		// ..B-G-R.. !!!
			}

		bmpin.close();
		return bmp;
	}//--end readBmp( String )	// ifn

	// read/skip n bytes
	static void skipb( FileInputStream in, int n ) throws IOException
	{
		for(int i=0; i<n; i++) in.read();
	}

	// read/return 2-byte-integer
	static int read2( FileInputStream in ) throws IOException
	{
		int i = in.read() + 256*in.read();
		return i;
	}


	// read/return 4-byte-long
	static long read4( FileInputStream in ) throws IOException
	{
		long l = 0, f = 1;
		for(int i=0; i<4; i++)
		{
			l = l + f * in.read();
			f = f * 256;
		}
		return l;
	}


	static void writeBmp( int[][] bmp, String fn )  throws IOException
	{
		writeBmp( bmp, fn, false );		// default: VerBose = false
	}//--end writeBmp( int[][], String )	// bmp,fn

	static void writeBmp( int[][] bmp, String fn, boolean vb ) throws IOException
	{
		int w = bmp[0].length/3;
		h = bmp.length;				// h x w pixel, h x 3*w bytes

		if(vb) prt( "writing file " + fn + " ....." );
		String tfn = null;			// Template to copy header from
		if( w==540 && h==360 )   tfn = new String( "T540x360.BMP" );	// artificial paradises, sizeof
		if( w==640 && h==480 )   tfn = new String( "T640x480.BMP" );	// 2DO: HOW-TO store bin.data in code?
		if( w==2480 && h==3508 ) tfn = new String( "T2480x3508.BMP" );	// A4  300 dpi
		if( w==1240 && h==1754 ) tfn = new String( "T1240x1754.BMP" );	// A4  150 dpi
		if( w==2544 && h==2880 ) tfn = new String( "T2544x2880.BMP" );	// ?

		if( tfn==null ) {
			prt( " XXXXXXXXXXX FATAL: not-(yet)-supported imagesize (" + w + "*" + h + ") for writeBmp()" );
			System.exit(33);
		}

		bmpin  = new FileInputStream(tfn);
		bmpout = new FileOutputStream(fn);
		for(int i=0; i<54; i++) bmpout.write(bmpin.read());	// copy header from template
		bmpin.close();

		// write bmp data to outfile:
		for(int ih=0; ih<h; ih++)
			for(int iw=0; iw<w*3; iw++) {
				bmpout.write( bmp[ih][iw] );
			}

		bmpout.close();
		if(vb) prt( "..... " + fn + " done." );

	}//--end writeBmp( int[][], String, boolean )	// bmp,fn,vb

	static void mkBmpHdr( String fn ) throws IOException
	{
		bmpin  = new FileInputStream(fn);
		// get h,w:
		skipb( bmpin, 18 );
		long  w = read4( bmpin );
		long  h = read4( bmpin );
		if( w%4 != 0) {
			prt("XXXXXX FATAL: NOT-supported width (not-divisible by 4) in " + fn );
			System.exit(338);
		}
		bmpin.close();

		// mk ofn:
		String ofn = new String( "T"+w+"x"+h+".BMP" );		// e.g. T640x480.BMP

		// copy header:
		bmpin  = new FileInputStream(fn);
		bmpout = new FileOutputStream(ofn);
 		for(int i=0; i<54; i++) bmpout.write(bmpin.read());
        bmpout.close();

		prt( "\nHeader-template " + ofn + " written. *bye*\n" );
		System.exit(0);
		// qqq
	}//--end mkBmpHdr( fn )




//================================== end wda's BITMAP-handling





	void waitImg( Image imgw )
	{
		prt( "   ---   waitImg()...   ---" );
		int arbitraryid = 17323;
		MediaTracker MT = new MediaTracker(this);

		MT.addImage( imgw, arbitraryid );

		try
		{
		    MT.waitForID( arbitraryid );
		}
		catch(InterruptedException e)
		{
		    System.out.println("Image loading interrupted : " + e);
		}

	}//--end waitImg( Image )



	static BufferedImage readBImg( String fn )	// does work in AV; DNW in browser
	{
		BufferedImage bImg=null;

		prt( NL + " readBImg( " + fn + " )   >>> " );

		try { bImg = ImageIO.read( new File(fn) ); }	// does not seem to need waitImg()
		catch(IOException ioe) { prt("XXXXXXXXX  IOException  XXXXXXXXXXXX" ); }

		if(bImg==null) prt( " *******    !ERROR! failed to load image from " + fn + "  *******");
		else if(VB)
		{
			prt( " +!+ loading image from " + fn + " may have succeeded +!+ " );

			prt( " widthxheight= " + bImg.getWidth() + " * " + bImg.getHeight() );
		}

		return bImg;
	}




//  ?better createImage  than getImg

	Image loadImg( String fn ) 		// DNW
	{
		prt( NL + " loadImg( " + fn + " )  >>> " );

//		Image i = getToolkit().getImage(getClass().getResource(fn));
		Image i = getToolkit().createImage(getClass().getResource(fn));
		waitImg( i );
		prt("             " + i.getWidth(null) + " * " + i.getHeight(this) );
		return i;
	}//--end loadImg( String )


	BufferedImage getBI( String fn )
	{
//		if(TEST) { showStatus( "loading image " + fn + " ...") ;	sleep(200); }

		Image ii = getImg( fn );

		BufferedImage BI = new BufferedImage(
									ii.getWidth(null), ii.getHeight(null),
									BufferedImage.TYPE_INT_RGB );
		Graphics gb = BI.getGraphics();
		gb.drawImage( ii, 0,0, null);

//		if(TEST) { showStatus( "image " + fn + " loaded.");	sleep(1200); }

		return BI;
	}//--end getBI( String )



	Image getImg( String fn )		// DNW without waitForImg
	{
		final boolean vb=false;

		if(vb) prt( "\n-----getImg() >>> doc..base= " + getDocumentBase() );
		if(vb) prt( " fn = " + fn );

		URL U = null;
		try
		{
			U = new URL( getDocumentBase(), fn );
			if(vb) prt( " URL: " + U.toString() );
		}
		catch(MalformedURLException e)
		{
			prt( "XXXXXXXXXXXXXXXXXXXXXXXXXX MalformedURLException" + e.getMessage() );
		}
		catch(Exception e)
		{
			prt( "XXXXXXXX FUKKKKJAVA  Exception" + e.getMessage() );
		}

		Image img = null;
//		img = Toolkit.getDefaultToolkit().getImage( U );		// ?SS := exatly the Same Shit
		img = Toolkit.getDefaultToolkit().createImage( U );		// OK, with waitImg
//		img = Toolkit.getDefaultToolkit().getImage( fn );		// SS?
//		img = Toolkit.getDefaultToolkit().createImage( fn );	// ?

		waitImg( img );

		if( img==null || img.getWidth(this)==-1)  prt( " ***!*** ERROR! Failed to load image from " + fn + " ***!*** " );
		else if(vb)  prt( " Loaded image from " + fn + " .. maybe OK " );

		return img;

	}//--end getImg( String )

// ---- end IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIImagstuff


	static int benoit( double x0, double y0, double rmax, int maxi )  // Mandelbrot's Apfelmaennchen
	{
		double x,y, r=0, xx,yy;
		int i;

		x = x0; y = y0;		// Mandelbrot
//		x0 = y0 = -0.25;	// Julia

		for( i=1; i<=maxi; i++ )
		{
			xx = x*x; yy = y*y;
			y = 2 * x * y + y0;		// complex  z(n) = z(n-1)**2 + z0
			x = xx - yy + x0;
			r = xx + yy;
			if( r > rmax ) return i;	// step i   0 < i <= maxi
		}

		i = -Int( 1048576 * r / rmax );
		if(i==0) i = -1;
		return i;	// "interior"		// 0 > i >= -1G

	}//--end benoit( double, double, double, int )


	static Color[] hueColors( int N, double s, double l )		// N = number, s=0..1, l=0..1
	{
		Color[] cols;
		cols = new Color[N];	// ok
		float h=0, dh;
		dh = (float)360 / (N+1);
		for( int i=0;i<N;i++ )
		{
			cols[i] = HSLColor( h, s, l );
			h += dh;
		}
		return cols;
	}//--end hueColors( int, double, double )	// N, s, l



//
// cloned from   http://www.codingforums.com/showthread.php?t=11156
//
	static Color HSLColor( double h, double s, double l )	// h=0..360, s=0..1, l=0..1
	{
		double r,g,b, m1,m2;

		if( s==0 ) r = g = b = l;
		else {
			if( l <= 0.5) m2 = l * (s+1);
			else          m2 = l + s - l*s;
			m1 = l * 2 - m2;
			h /= 360;
			r = h2rgb(m1, m2, h + 1.0/3);
			g = h2rgb(m1, m2, h);
			b = h2rgb(m1, m2, h - 1.0/3);
		}
		return new Color( (float)r, (float)g, (float)b );
	}//--end HSLColor

	static double h2rgb( double m1, double m2, double h)
	{
		double v;
		if( h<0 ) h += 1;
		else if (h > 1 ) h -= 1;

		if( 6*h < 1 )		v = m1 + (m2 - m1) * h * 6;
		else if (2 * h < 1)	v = m2;
		else if (3 * h < 2)	v = m1 + (m2 - m1) * (2.0/3 - h) * 6;
		else				v = m1;

		return v;
	}



	static int Int(String str) { return Integer.parseInt( str ); }
	static int Int(double xxx) { return (int) Math.floor(xxx);    }	// cutoff
	static int RInt(double xxx) { return (int) Math.rint(xxx);    }	// rounded int i = Math.rint(xxx) = "error" possible loss of precision !!!

	static void prt(String s) { System.out.println(s); }

	static void sleep( int ms ) {
		try { Thread.sleep(ms); } catch (java.lang.InterruptedException e) { /* System.exit(1); */ }
	}

	static String threadName()	{ return Thread.currentThread().getName(); }


	// COPY BINary, nbytes from ifn to ofn
	void copyBin( String ifn, String ofn, long nbytes) throws IOException
	{
		//...
	}



}