package wda;

/*																McCopies & D.Stribute   2139

Corrections or Suggestions4Improvement (ALWAYS) welcome.  -- Y.T. o5@utanet.at

FRACTALS
=========
0.1  basic Mandelbrot set with ncols-hueColors-palette
0.2  color animate from saved values
0.3  MouseListener & KeyListener
0.4  generate bImgs -> bImgsReady -> display'em
1.01  <iI>/<oO> .. zoom In/Out; <u>/<U> .. Undo; <n>/<N> .. adjust Nmax
1.02  deleting random-currencied-SWASTIKA and dead code
1.02  <asv.,>, mouse.right
1.02  pre-set-images: IPS; <l>; pal2; <cC>; stretchPalette()


?2DO?
- read palette from file
- <F> select from list






Notes
-----
java <-> longNames	<==>  own = shortNames
e.g.      getImage()              getImg()



*/

import static wda.Utils.*;	// -> benoit(), hueColors(), prt(), sleep(), threadName(), ...

import javax.imageio.*; // -> ImageIO
import java.io.*;		// -> File
import java.util.ArrayList;
import java.util.Random;
import java.net.*;		// -> URL

import javax.swing.*;	// -> JApplet, JButton, init/start/stop//repaint,setBackground,drawString/showStatus
import static javax.swing.JOptionPane.showInputDialog;
import static javax.swing.JOptionPane.PLAIN_MESSAGE;
// import static javax.swing.JOptionPane.DEFAULT_OPTION;
import static javax.swing.JOptionPane.showMessageDialog;
import static javax.swing.JOptionPane.INFORMATION_MESSAGE;

//	-- " Abstract Window Toolkit " --
import java.awt.*;		// -> Graphics, Color
import java.awt.image.*;// -> BufferedImage
import static java.awt.image.BufferedImage.TYPE_INT_RGB;
import java.awt.event.MouseListener;
import java.awt.event.MouseAdapter;
import java.awt.event.*;	// -> MouseEvent, KeyAdapter

import static java.net.URLEncoder.encode;	// encode()


class IP		// Image Parameters    (( e.g. colors := Display Param.s))
{
	// instance vars:
	protected double  xmin, xmax, ymin, ymax;
	protected int nmax;
	protected String inam;
	// constructor:
	IP( double xmin, double ymin, double xmax, double ymax, int nmax, String inam )	{
		this.xmin=xmin;
		this.xmax=xmax;
		this.ymin=ymin;
		this.ymax=ymax;
		this.nmax=nmax;
		this.inam=inam;
	}
	
} //--end class IP




public class wfract extends JApplet implements Runnable // -> run()
{
	
	public static void main(String[] args){}	// fukkkjava&JCreator

	final static String VERS = new String( " 1.02-99" );
	final static boolean  VB = false;
	final static String   NL = new String( "\n");

	static boolean runFlag0  = true;
	static boolean runFlag, runFlag3;

	int w, h;	// w/h of applet

	Thread thr2=null, thr3=null;

	BufferedImage bImg = null;
	Graphics2D gBuf = null;
	
	public static Random RG = new Random();	// a RandomGenerator

	static final ArrayList IPS = new ArrayList(20);		// ImageParameterS
	// IPS.add( anything );    NOT ALLOWED HERE

	// Apfelmaennchen:
	static int ncols = 32;
	Color[] cols;
	Color[] pal2;	// palette 2  (( p.1 = huecols )
	Color col0;
	double xmax, xmin, ymin, ymax;
	double pxmax, pxmin, pymin, pymax;	// Previous values
	double zzmax=500;		// limit for z**2 in benoit()
	int nmax, pnmax;		// "maximale Rechentiefe", Previous value
	int nmaxx=10000;		// maximale "maximale Rechentiefe"
	int[][] vals;
	int z2min, z2max;
	BufferedImage[] bImgs;		// array of bImg's for color-anim
	int iImgs = 0;				// index into these bImg's
	boolean bImgsReady = false;
	static final int fps0 = 25;
	static int fps = fps0;		// Frames Per Second

	static final String VVTXT = NL+"Corrections or Suggestions4Improvement (ALWAYS) welcome." + 
		"  -- Y.T. o5@utanet.at" + NL;

	static final String htxt = NL + NL + "MOUSE:\n single click left to reset; single click right to center" + NL +
		" drag left button to select area or right button to shift image" + NL + NL +
		"KEYS:\n <space> stop/restart color animation; <-> / <+> for Slower / Faster  " + NL +
		" <4> | <6> move area 1/2 width; <8> | <2> move 1/2 height" + NL + 
		" <i>,<I> / <o>,<O> zoom In / Out;  <a> reset aspect ratio" + NL + 
		" <v> center vertically;  <u> Undo last area-change" + NL + 
		" <n> adjust Nmax;   <h> display this helptext" + NL + 
		" <s> OR mouse-click into top left corner .. Save current image parameters;  " + NL + 
		" <l> load Preset image;  <cC> change color;   <r> reset " + NL + 
		"\nSIZE may be adjusted in wfract.htm." + NL;

	int x1,y1;	// mouse coord's

//	JApplet ja1;	// does NOT work
	JPanel jp1;
	//..

	void resetSize()
	{
		prt( "\n---resetting...---" );
		xmin=-2.5;
		xmax=1.5;
		ymin=-1.5;
		ymax=1.5;
		zzmax=500;
		nmax=100;
	}

	@Override
	public void paint( Graphics g)
//	public void paintComponent( Graphics g)  ///method does not override or implement a method from a supertype
	{
//		if(VB) prt( "-----paint-----");

//		super.paint( g );	//??  NOGOOD for fractals !
		drawImg( g, bImgs[iImgs], 0, 0 );
	}


	void drawImg( Graphics g, BufferedImage b, int x, int y ) {
		g.drawImage( b, x, y, this);
	}


// IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII



	void drawImg( Graphics g, Image i, int x0, int y0, int w, int h) {
		g.drawImage( i, x0,y0, w,h, null );
	}

	private void waitImg( Image imgw )
	{
		prt( "   ---   waitImg()...   ---" );
		int arbitraryid = 17323;
		MediaTracker MT = new MediaTracker(this);

		MT.addImage( imgw, arbitraryid );

		try
		{
		    MT.waitForID( arbitraryid );
		}
		catch(InterruptedException e)
		{
		    System.out.println("Image loading interrupted : " + e);
		}

	}	//-----*/




	@Override
	public void run()
	{
		if(VB) prt( "-----run-----");

		String thn = threadName();
//		prt( "***run " + thn );
		if( thn.equals("TH3") )	// TH3
		{ 
			runFlag3 = true;
			while(runFlag3)
			{
				sleep(55000);	// every 55 seconds
				prt( VVTXT );	// show VVTXT
			}
			return;
		}//--endif TH3

		// TH2 .. image display and color animation:
		runFlag = runFlag0;
		while(true)
		{
			int c=0;		// color offset for animation
			int x,y,z;

			//
			//	 generate Color Animation
			//
			prt( "  --  generating color-animation ..." );
			int ii=0;
			if( !bImgsReady) for( ii=0; ii<ncols && runFlag; ii++)	// ncols Images, 1 already done
			{
				BufferedImage bI = new BufferedImage( w,h, TYPE_INT_RGB);
				gBuf = bI.createGraphics();
				bImgs[ii] = bI;

				c++;
				for( y=0; y<h; y++)		// lines
				{
					for( x=0; x<w; x++)	// pixels
					{
						z = vals[x][y];
						gBuf.setColor( z2cola( z, c ) );
						gBuf.fillRect( x,y, 1,1 );
					}
				}
				iImgs = ii;
				repaint();
			}
			if(ii==ncols) bImgsReady = true;

			//
			//  playback color animation
			//
			if(runFlag) prt( "  --  displaying color-animation, " + fps + " fps ..." );
			while(runFlag)
			{
				long ms = System.currentTimeMillis();	// starttime in MSec
				iImgs++;
				if(iImgs>=ncols) iImgs = 0;

				repaint();

				ms = System.currentTimeMillis() - ms;	// MilliSeconds elapsed
				long mspf = 1000/fps;	// MilliSecs Per Frame
				int ms2w = (int) (mspf - ms);		// MSecs 2 Wait
				if( ms2w < 0 ) prt( " system too slow for this image; color-anim maybe not smooth " );
				else sleep( ms2w );
			}
			if(runFlag) prt("???????????????????????????????????????????????????");
		
			while( !runFlag) sleep(200);		// wait for runFlag

		}//endwhile(true)


	}//--end run()



	@Override
	public void init()
	{
		if(VB) prt( "-----init-----");

//		ja1 = new JApplet();	// does NOT work
		jp1 = new JPanel();		// DOES seem to work
		getContentPane().add( jp1 );
		jp1.setBackground( new Color(224, 224, 224) );  // hell-cyans

//		jp1.setDefaultCloseOperation(jp1.EXIT_ON_CLOSE);	// NOPE.	windows/frame ONLY
//		jp1.setTitle(" oink " );							// NOPE.	windows/frame ONLY (frakkkJava)

		w = getWidth();
		h = getHeight();		// Applet-Size
	
		vals = new int[w][h];
		bImgs = new BufferedImage[ncols];
		resetSize();	// set size
		
		//	=====	IIIIIPSIPSIPS    pre-set-images	=====
		//   ((( in python wuerd ich es einfach aus einem """ string """ rauslesen ... ))), aber so geht's auch ...


		IPS.add( new IP( -1.7868581053437513,-9.2124938E-8, -1.786857905343749,9.2124938E-8 ,
							1000 , "wda001") );
		IPS.add( new IP( -1.80673825140625,-0.03025527375000001, -1.7196410291406248,0.03025527375000001 ,
						 	210 , "wda_Apfel_2" ) );
		IPS.add( new IP( -1.9454365586721527,-0.002203687500000002, -1.9371210648105464,0.002203687500000002 ,
							1427 , "wda_Apfel_3" ) );						 
		IPS.add( new IP( -1.9449884828911408,-2.1810308378906296E-6, -1.9449822245370552,2.1810308378906296E-6 ,
							2000 , "wda_Apfel_4" ) );						 

	
		//    --- Ying/Yang im WIRBEL  ---
		//  x/y=0.7509/-0.025 und einer maximalen rechentiefe von 700 (((vor jahren aufgeschrieben..&immer noch da!)))
/*---	double dd = 0.01;
		IPS.add( new IP( -0.7509-dd, -0.025-dd, -0.7509+dd, -0.025+dd,
							700, "wda_Wirbel_386" ) );					---*/
		IPS.add( new IP( -0.7509110001416884,-0.02499884106445313, -0.7508980279604366,-0.024987805908203126 ,
							700 , "wda_Wirbel_1" ) );
								
		IPS.add( new IP( -0.7451547939876545,-0.1353313869375001, -0.7449588544814817,-0.13511344631250008 ,
					660 , "wda_spiral_23" ) );
								 
//		IPS.add( new IP( xxxxINSERTHERExxxx ) );						 
//		IPS.add( new IP( xxxxINSERTHERExxxx ) );						 
//		IPS.add( new IP( xxxxINSERTHERExxxx ) );						 
//		IPS.add( new IP( xxxxINSERTHERExxxx ) );						 
//		IPS.add( new IP( xxxxINSERTHERExxxx ) );						 
//		IPS.add( new IP( xxxxINSERTHERExxxx ) );	


		//	=====	PALETTE  2 	=====	
		pal2 = new Color[16];
		pal2[0] = new Color( 92, 0, 61 );
		pal2[1] = new Color( 122, 0, 122 );
		pal2[2] = new Color( 0, 0, 253 );
		pal2[3] = new Color( 168, 168, 168 );
		pal2[4] = new Color( 122, 0, 192 );
		pal2[5] = new Color( 97, 2, 227 );
		pal2[6] = new Color( 89, 89, 89 );
		pal2[7] = new Color( 2, 84, 217 );
		pal2[8] = new Color( 0, 125, 192 );
		pal2[9] = new Color( 0, 125, 125 );
		pal2[10] = new Color( 0, 0, 92 );
		pal2[11] = new Color( 250, 250, 243 );
		pal2[12] = new Color( 0, 92, 61 );
		pal2[13] = new Color( 0, 61, 0 );
		pal2[14] = new Color( 0, 0, 0 );
		pal2[15] = new Color( 64, 0, 0 );
				



		//	=====	=====
		
		addMouseListener( new MouseAdapter()
		{
			public void mouseExited(MouseEvent me)
			{
//					showStatus(" mouse.exit ");
			}
			public void mousePressed(MouseEvent me)
			{
				runFlag = false;
				x1 = me.getX(); y1 = me.getY();
				prt(" mouse.pressed at (" + x1 + "/" + y1 + ")" );
			}
			public void mouseReleased(MouseEvent me)
			{
				int x2 = me.getX(); int y2 = me.getY();

				prt("");
//				prt("\nMOUSE EVENT= " + me + "  Button=" + me.getButton() );
				prt(" mouse.released at (" + x2 + "/" + y2 + ")" );
				prt( "old xmin/max, ymin/max = " + xyStr() );
	
				
				saveVals();
				if( me.getButton()==1 )		// leftButton -> crop area:
				{
					if( x1==x2 || y1==y2 )
					{
						int f=8;
						if( x1<w/f && y1<h/f ) saveIP();
						else resetSize();
					}
					else
					{
						if(x2<x1) { int x3=x1; x1=x2; x2=x3; }
						if(y2<y1) { int y3=y1; y1=y2; y2=y3; }
						
						double xf = (xmax-xmin)/w;
						xmin = xmin + x1 * xf;
						xmax = xmax - (w-x2) * xf;
						double yf = (ymax-ymin)/h;
						ymin = ymin + y1 * yf;
						ymax = ymax - (h-y2)*yf;			// scale area		
						
						nmax *= Math.sqrt(Math.sqrt(w/(x2-x1)));		// adjust Rechentiefe
						if( nmax > nmaxx ) nmax = nmaxx;							
					}
									
				}
				else					// rightButton -> shift image area:
				{
					double dx, dy;
					if( x1==x2 && y1==y2 ) 	// center x1/y1
					{
						dx = (xmax-xmin)*(w/2.-x1)/w;
						dy = (ymax-ymin)*(h/2.-y1)/h;					
					}
					else		// shift from x1/y1 to x2/y2
					{
						dx = (xmax-xmin)*(x2-x1)/w;
						dy = (ymax-ymin)*(y2-y1)/h;
					}
					xmin -= dx; xmax -= dx;
					ymin -= dy; ymax -= dy;							
				}

				prt( "new xmin/max, ymin/max = " + xyStr() );
	
				calcFract();
			}
		} ) ;//--end MouseListener
	
		addKeyListener( new KeyAdapter()
		{
		 	public void keyTyped( KeyEvent ke ) {
		 		char c = ke.getKeyChar();
		 		if( c=='h' || c=='H' )
		 		{
		 			prt( htxt );
		 			showMessageDialog(null, htxt, "  wda's Apfelmnnchen  VERS " + VERS, INFORMATION_MESSAGE);
		 		}
		 		else if( c=='r' || c=='R' )
		 		{
		 			prt("\n---resetting---");
		 			saveVals();
		 			resetSize();
		 			calcFract();
		 		}
		 		else if( c==' ' )	// blank .. stop/start
		 			runFlag = !runFlag;
		 		else if( c=='\n')	// enter .. start
		 			runFlag = true;
		 		else if( c=='-' ) {	// Slower
		 			if(fps>1)		// no slower than 1 fps
		 				prt( " slower: fps= " + --fps);
		 		}
		 		else if( c=='+' )			// Faster
		 			prt( " faster: fps= " + ++fps);
		 		else if( c=='.' )	{		// slow mo
		 			fps = 1;
		 			prt( " slo mo: fps= " + fps );
		 		}
		 		else if( c==',' )	{		// 
		 			fps = fps0;
		 			prt( " default: fps= " + fps );
		 		}		 		
		 		else if( c=='6' )	// go right
		 		{
		 			prt("\n---moving right---");
		 			saveVals();
		 			double dx = (xmax-xmin)/2;
		 			xmin += dx; xmax += dx;
		 			calcFract();
		 		}
		 		else if( c=='4' )	// go left
		 		{
		 			prt("\n---moving left---");
		 			saveVals();
		 			double dx = (xmax-xmin)/2;
		 			xmin -= dx; xmax -= dx;
		 			calcFract();
		 		}
		 		else if( c=='8' )	// go up
		 		{
		 			prt("\n---moving up---");
		 			saveVals();
		 			double dy = (ymax-ymin)/2;
		 			ymin -= dy; ymax -= dy;
		 			calcFract();
		 		}
		 		else if( c=='2' )	// go down
		 		{
		 			prt("\n---moving down---");
		 			saveVals();
		 			double dy = (ymax-ymin)/2;
		 			ymin += dy; ymax += dy;
		 			calcFract();
		 		}
		 		else if( c=='o' || c=='O' )
		 		{
		 			prt("\n---zooming Out...---");
		 			saveVals();
		 			double f = 0.5;		// size: 1 + 2* 1/2 -> 2
		 			if(c=='O') f = 1.5;		//   1 + 2* 3/2 -> 4
		 			double dx = (xmax-xmin)*f;
		 			double dy = (ymax-ymin)*f;
					xmin -= dx; xmax += dx;
					ymin -= dy; ymax += dy;
		 			calcFract();		 			
		 		}
		 		else if( c=='i' || c=='I' )
		 		{
		 			prt("\n---zooming In...---");
		 			saveVals();
		 			double f = 0.25;	//  size: 1 - 2* 1/4 -> 1/2
		 			if(c=='I') f = 3./8;	//    1 - 2* 3/8 -> 1/4
		 			double dx = ( xmax-xmin)*f;
		 			double dy = (ymax-ymin)*f;
					xmin += dx; xmax -= dx;
					ymin += dy; ymax -= dy;
		 			calcFract();		 			
		 		}		 		
		 		else if( c=='v' || c=='V' )
		 		{
		 			prt("\n---centering vertically...---");
		 			ymax = (ymax-ymin)/2.;
					ymin = -ymax;
		 			calcFract();		 			
		 		}
		 		else if( c=='a' || c=='A' )
		 		{
		 			prt("\n---resetting aspect ratio...---");
		 			double ar = w*1.0/h;	// Aspect Ratio = display-width:height, ..from htm
		 			double xs = xmax - xmin;
		 			double ys = ymax - ymin;	// Size of mandelbrot-clip
		 			double a = xs/ys;			// A.r. of above
//		 			if( a>ar )	// NOPE. KISS! simply adjust x, always...
					if( a==ar )	{
						prt( " ..ain't necessary." );
						return;
					}
					double dx = xs*(1.-a/ar)/2;
					xmax += dx; xmin -= dx;
					calcFract();		 			
		 		}		 		
		 		else if( c=='u' || c=='U' )
		 		{
		 			prt("\n---undoing...---");
		 			xmin = pxmin; xmax = pxmax;
					ymin = pymin; ymax = pymax;
					nmax = pnmax;
		 			calcFract();		 			
		 		}
		 			
		 		else if( c=='l' || c=='L' )
		 		{
		 			saveVals();
		 			int nIPS = IPS.size();			// Number of Image Parameters in store
		 			int iIPS = RG.nextInt(nIPS);	// a random Index
		 			IP ip = (IP) IPS.get( iIPS );	// note the EXPLICIT MUSZT-DO type cast - fukk'g-Java doesnt seem to know the type of an object it has stored in an ArrayList
		 			prt("\n---Loading \"" + ip.inam + "\" ="  + (iIPS+1) + ". (of " + nIPS + ") pre-set images...---");
		 			xmin = ip.xmin; xmax = ip.xmax;
					ymin = ip.ymin; ymax = ip.ymax;
					nmax = ip.nmax;
		 			calcFract();		 			
		 		}
		 		else if( c=='n' || c=='N' )
		 		{
		 			prt( "\n---adjusting Nmax...---" );
					int nnmax = 0;	// New NMAX; must be integer and >0
					while(nnmax<1)
					{
						try {
							String retval = (String) showInputDialog( null
											, " nmax=" + nmax + "; enter new value:"
											, "wfract"
											, PLAIN_MESSAGE, null, null, ""
											 );	//
//							prt("RETVAL=" + retval);
							if(retval==null) nnmax = nmax;	// Cancel
							else nnmax = Int(retval);		// OK
						}
						catch( Exception e ) {
							prt( " try again. nmax must be integer and >0. " );
						}
					}
					if(nmax!=nnmax)
					{
						nmax = nnmax;
			 			calcFract();		 									
					}
		 		}
		 		else if( c=='c' ) 	// huecolors
		 		{
		 			runFlag = false;
		 			prt( "\n--- new number of 'huecolors' ? ... ---" );
					int nncols = 0;	// New NCOLS; must be integer and >1
					while(nncols<2)
					{
						try {
							String retval = (String) showInputDialog( null
											, "enter new number of colors:"
											, "wfract"
											, PLAIN_MESSAGE, null, null, "" + ncols
											 );	//
//							prt("RETVAL=" + retval);
							if(retval==null) nncols = ncols;	// Cancel
							else nncols = Int(retval);		// OK
						}
						catch( Exception e ) {
							prt( " try again. nr_cols must be integer and >1. " );
						}
					}
					if(nncols!=ncols)
					{
						ncols = nncols;
						setcols();
						bImgs = new BufferedImage[ncols];	// resize image storage
						iImgs = 0;
						calcFract();
					}		 			
		 		}
		 		else if( c=='C' ) 	// palette 2
		 		{
		 			runFlag = false;
		 			// ask for 'strecht factor' k:
		 			int k = 1;
		 			int nc2 = pal2.length;		 			
					try {
						String retval = (String) showInputDialog( null
										, "'stretch' palette2 by factor of ?"
										, "wfract"
										, PLAIN_MESSAGE, null, null, "1"
										 );	//
//							prt("RETVAL=" + retval);
						if(retval!=null) k = Int(retval);		// OK
						if(k<1) k = 1;
						prt( "-- " + k*nc2 + "  colors --" );
					}
					catch( Exception e ) {
						k = 1;	 			
					}
//		 			int k = 2;			// 'palette stretch factor'
		 			int nncols = nc2*k;	// New NCOLS
		 			if( ncols!=nncols)
		 			{
		 				ncols = nncols;
		 				bImgs = new BufferedImage[ncols];
		 				iImgs = 0;
		 			}
//		 			cols = pal2;	// OK
		 			cols = stretchPalette( pal2, k);
		 			calcFract();
		 		}		 		
		 		else if( c=='s' || c=='S' )	// Save Image Params.
		 		{
		 			saveIP();
		 		}		 		
		 			 		
		 		else prt( "\n  KeyTyped: " + ke + "KeyChar=" + c );
		 	}
	
		 	public void keyPressed( KeyEvent ke ) {
//			 		prt( "  keyPressed: " + ke );
		 	}
	
		 	public void keyReleased( KeyEvent ke ) {
//			 		prt( "  keyReleased: " + ke );
		 	}
		} ); //--end KeyListener


		if( bImg==null )
		{
			BufferedImage bI = new BufferedImage( w,h, TYPE_INT_RGB);
			gBuf = bI.createGraphics();

			bImgs[0] = bI;
		}
	} //--end init()

	
	void setcols()
	{
		prt( "\nncols = " + ncols + "\ncalculating ... ");
		cols = hueColors( ncols, 1, 0.5 );		
	}
	
	
	
	Color mergeCols( Color col1, Color col2, double w1 )	// mix w1*col1 + (1-w1)*col2
	{
		double w2 = 1 - w1;
		int r = Int( w1*col1.getRed()   + w2*col2.getRed()   );
		int g = Int( w1*col1.getGreen() + w2*col2.getGreen() );
		int b = Int( w1*col1.getBlue()  + w2*col2.getBlue()  );
		Color col3 = new Color( r,g,b );
		return col3;
	}
	
	Color[]  stretchPalette( Color[] pal, int k )	// pal..nc colors; return npal with k*nc colors
	{
		Color[] npal;	// New PALette
		int nc = pal.length;
		int ipal = 0;
		npal = new Color[ nc*k ];
		double f = 1.0/(k+1);
		for(int i1=0; i1<nc; i1++)
		{
			int i2 = i1 + 1;
			if(i2==nc) i2 = 0;
			for(int j=1; j<=k; j++)
			{
				npal[ ipal++ ] = mergeCols( pal[i1], pal[i2], 1.0-j*f );
			}
		}
		return npal;
	}

	@Override
	public void start()
	{
		if(VB) prt( "-----start-----");

		prt( "\n\n\n*******  wfract version" + VERS + "  ++++++++" + NL );
		prt( htxt );
		prt( VVTXT );
		
		setcols();
		col0 = new Color( 127,127,127 );

		calcFract();

		repaint();
		if(VB) prt( "-----start_called_repaint()-----");


		if(thr2==null )
		{
			thr2 = new Thread(this, "TH2" );
			runFlag = true;
			thr2.start();
			
			thr3 = new Thread(this, "TH3" );
			thr3.start();
		}


	} //--end start()	////  showStatus  "  Applet gestartet  "
	

	
	void saveVals()
	{
		pxmax = xmax; pxmin = xmin;
		pymin = ymin; pymax = ymax;
		pnmax = nmax;		
	}

	void setPixel( Graphics2D gbuf, Color col, int x, int y )	{
		gbuf.setColor( col );
		gbuf.fillRect( x,y, 1,1 );
	}	
		
	String xyStr()	// return String with "xmin/ymin, xmax/ymax"
	{
		return ( xmin + "," + ymin + ", " + xmax + "," + ymax );
	}
	
	String xynStr()	// return String with "xmin/ymin, xmax/ymax ; nmax"
	{
		return ( xyStr() + " , " + nmax );
	}



	String encodeUTF8( String str)
	{
		try
		{
			return encode( str, "UTF-8" );
		}
		catch( UnsupportedEncodingException uee )
		{
			// frakkkkjava
			return "UnsupportedEncodingException";
		}
	}
	
	
	
	private void saveIP()
	{
		prt( "\n--SAVE image parameters:---" );
		String inam = (String) showInputDialog( null
								, " saving image param.s; enter image name:"
								, "wfract"
								, PLAIN_MESSAGE, null, null, ""
								 );	//
		if( inam==null ) inam = new String( " <<GRRR. no name given>> " );
		prt( "=== " + inam + " ===" );
		String ip = xynStr() + " , \"" + inam + "\"";	// Image Parameters
		prt( ip + NL );	
		String ipe = encodeUTF8( ip );	// I.P. Encoded
		prt( ipe + NL );
		savTxt( ipe );	// -> http://wda.tradivarium.at/msg2wda.txt
		// save where/how?  applets cannot write to disk, or can they ?		
	}//--end saveIP()

	
	private void savTxt( String txt)
	{
		String url = new String( "http://wda.tradivarium.at/savemsg.php?inp1=" + encodeUTF8(txt) );
		openURL( url );
	}
	
	private void openURL( String url)
	{
		openURL( url, "_blank");
	}
	
	private void openURL( String url, String target)
	{	
		try {
			getAppletContext().showDocument( new URL(url), target );
			getAppletContext().showStatus( "URL: " + url + " ..OK" );
			prt( "showDocument(" + url + ") .... OK" );
		}
		catch(MalformedURLException me)  {
			getAppletContext().showStatus( "XXX invalid URL: " + url + " XXX" );
			prt( "showDocument(" + url + ") .... failed" );
		}
	}	
	

	void calcFract()
	{
		int x,y, z;
		double xx,yy, xf, yf;
		runFlag = false;				// disable run()
		
		prt( "==calcFract(" + xynStr() + ")==" );
		double dx = (xmax-xmin);
		double dy = (ymax-ymin);
		prt( "xsize,ysize= " + dx + "," + dy + "    nmax= " + nmax + " s  a.r.= " + dx/dy );
		prt( " --   calculating ..." );

		//
		// calculate, save & draw
		//
		xf = (double)(xmax-xmin)/w;
		yf = (double)(ymax-ymin)/h;

		z2min = 0;
		z2max = -4000000;

		for( y=0; y<h; y++)
		{
			yy = ymin + y*yf;

			for( x=0; x<w; x++)
			{
				xx = xmin + x*xf;

				z = benoit( xx,yy, zzmax, nmax );
				vals[x][y] = z;
				if( z<0 )
					if( z<z2min ) z2min = z;
					else if( z>z2max ) z2max = z;	// determine range for z-vals < 0 , i.e. "interior"; for FUTURE e.g. shading 
				setPixel( gBuf, z2col( z ), x,y );
			}
		}
		repaint();
//		sleep(5000);
		bImgsReady = false;
		runFlag = true;	// enable run()
		
	} //--end calcFract()


	Color z2col( int z ) { return z2cola( z, 0 ); }
	Color z2cola( int z, int a)
	{
		if(z<0) return col0;
		else    return cols[ (z+a) % ncols ];
	}


	@Override
	public void stop()
	{
		if(thr2==null) return;
		runFlag = false;
		runFlag3 = false;		
		thr2 = null;
		thr3 = null;
	}

}//--end class wfract --------------------------------

